# Case Study of Evaluating Porting Costs: Porting IxOS on ARM Boards

The software porting process is costly and time consuming. Software reuse has
become a standard practice in software engineering due to its cost saving
benefits, therefore it is important to understand the framework for quantifying
the costs of reuse so that the process can be optimized. In order to explore
this issue, we take our experience of porting the Ixia network testing
infrastructure on a popular, off-the-shelf system that supports Linux, such as
Raspberry Pi and extract the porting costs associated with this process. This
leads us to a revised model of porting based on which we extract the costs for
our project. Furthermore we present the factors that affect the porting and their
direct correspondence with the porting model and costs. We discover that the
porting process is not linearly dependent on the degree of portability of the
system, it very much depends on the familiarity of the developer with the
system. Finally, we discuss the limitations of our porting model and make a
comparison with the old porting model.

# Files and directories

* scss/ - sources for the paper presented in UPB SCSS Conference
* src/  - source for the Bacherlor's Thesis
* The files in the root directory are notes taken during the months of preparing
the final version of the thesis.
